//==================================================================================================
/*
  EVE - Expressive Vector Engine
  Copyright : EVE Project Contributors
  SPDX-License-Identifier: BSL-1.0
*/
//==================================================================================================
#pragma once

//==================================================================================================
//! @addtogroup algorithms
//! @{
//!   @defgroup algos Algorithms
//!   @brief Provides SIMD implementation of standard algorithms
//!
//!   @defgroup views Views
//!   @brief Provides views to work with SIMD algorihms
//!
//!   @defgroup algo_concepts Concepts
//!   @brief Provides Concepts for algorithms and related components
//! @}
//==================================================================================================
#include <eve/module/core.hpp>
#include <eve/algo/concepts/eve_iterator.hpp>
#include <eve/algo/concepts/ranges_types.hpp>
#include <eve/algo/concepts/nothing.hpp>
#include <eve/algo/concepts/relaxed.hpp>
#include <eve/algo/concepts/types_to_consider.hpp>
#include <eve/algo/concepts/zip_to_range.hpp>
