//==================================================================================================
/**
  EVE - Expressive Vector Engine
  Copyright : EVE Project Contributors
  SPDX-License-Identifier: BSL-1.0
**/
//==================================================================================================
#pragma once

//==================================================================================================
//! @addtogroup functions
//! @{
//! @defgroup bessel Bessel function
//! @brief Bessel functions
//!
//! This module provides implementation for the
//! [Bessel functions](https://en.wikipedia.org/wiki/Bessel_function) and related operations.
//!
//! **Required header:** @code{.cpp} #include <eve/module/bessel.hpp> @endcode
//!
//! @}
//==================================================================================================
#include <eve/module/bessel/regular/bessel.hpp>
