//==================================================================================================
/*
  EVE - Expressive Vector Engine
  Copyright : EVE Project Contributors
  SPDX-License-Identifier: BSL-1.0
*/
//==================================================================================================
#pragma once

#include <eve/module/math/constant/catalan.hpp>
#include <eve/module/math/constant/cbrt_pi.hpp>
#include <eve/module/math/constant/cos_1.hpp>
#include <eve/module/math/constant/cosh_1.hpp>
#include <eve/module/math/constant/egamma.hpp>
#include <eve/module/math/constant/egamma_sqr.hpp>
#include <eve/module/math/constant/epso_2.hpp>
#include <eve/module/math/constant/euler.hpp>
#include <eve/module/math/constant/exp_pi.hpp>
#include <eve/module/math/constant/extreme_value_skewness.hpp>
#include <eve/module/math/constant/four_minus_pi.hpp>
#include <eve/module/math/constant/four_pio_3.hpp>
#include <eve/module/math/constant/glaisher.hpp>
#include <eve/module/math/constant/inv_2eps.hpp>
#include <eve/module/math/constant/inv_e.hpp>
#include <eve/module/math/constant/inv_egamma.hpp>
#include <eve/module/math/constant/inv_pi.hpp>
#include <eve/module/math/constant/invcbrt_pi.hpp>
#include <eve/module/math/constant/invlog10_2.hpp>
#include <eve/module/math/constant/invlog10_e.hpp>
#include <eve/module/math/constant/invlog_10.hpp>
#include <eve/module/math/constant/invlog_2.hpp>
#include <eve/module/math/constant/invlog_phi.hpp>
#include <eve/module/math/constant/invsqrt_2.hpp>
#include <eve/module/math/constant/khinchin.hpp>
#include <eve/module/math/constant/log10_e.hpp>
#include <eve/module/math/constant/log2_e.hpp>
#include <eve/module/math/constant/log_10.hpp>
#include <eve/module/math/constant/log_2.hpp>
#include <eve/module/math/constant/log_phi.hpp>
#include <eve/module/math/constant/loglog_2.hpp>
#include <eve/module/math/constant/maxlog.hpp>
#include <eve/module/math/constant/maxlog10.hpp>
#include <eve/module/math/constant/maxlog2.hpp>
#include <eve/module/math/constant/minlog.hpp>
#include <eve/module/math/constant/minlog10.hpp>
#include <eve/module/math/constant/minlog10denormal.hpp>
#include <eve/module/math/constant/minlog2.hpp>
#include <eve/module/math/constant/minlog2denormal.hpp>
#include <eve/module/math/constant/minlogdenormal.hpp>
#include <eve/module/math/constant/phi.hpp>
#include <eve/module/math/constant/pi.hpp>
#include <eve/module/math/constant/pi2.hpp>
#include <eve/module/math/constant/pi2o_16.hpp>
#include <eve/module/math/constant/pi2o_6.hpp>
#include <eve/module/math/constant/pi3.hpp>
#include <eve/module/math/constant/pi_minus_3.hpp>
#include <eve/module/math/constant/pi_pow_e.hpp>
#include <eve/module/math/constant/pio_3.hpp>
#include <eve/module/math/constant/pio_4.hpp>
#include <eve/module/math/constant/pio_6.hpp>
#include <eve/module/math/constant/rayleigh_kurtosis.hpp>
#include <eve/module/math/constant/rayleigh_kurtosis_excess.hpp>
#include <eve/module/math/constant/rayleigh_skewness.hpp>
#include <eve/module/math/constant/rsqrt_2pi.hpp>
#include <eve/module/math/constant/rsqrt_e.hpp>
#include <eve/module/math/constant/rsqrt_pi.hpp>
#include <eve/module/math/constant/rsqrt_pio_2.hpp>
#include <eve/module/math/constant/sin_1.hpp>
#include <eve/module/math/constant/sinh_1.hpp>
#include <eve/module/math/constant/sixth.hpp>
#include <eve/module/math/constant/sqrt_2.hpp>
#include <eve/module/math/constant/sqrt_2pi.hpp>
#include <eve/module/math/constant/sqrt_3.hpp>
#include <eve/module/math/constant/sqrt_e.hpp>
#include <eve/module/math/constant/sqrt_pi.hpp>
#include <eve/module/math/constant/sqrt_pio_2.hpp>
#include <eve/module/math/constant/sqrtlog_4.hpp>
#include <eve/module/math/constant/third.hpp>
#include <eve/module/math/constant/three_o_4.hpp>
#include <eve/module/math/constant/three_pio_4.hpp>
#include <eve/module/math/constant/two_o_3.hpp>
#include <eve/module/math/constant/two_o_pi.hpp>
#include <eve/module/math/constant/two_o_sqrt_pi.hpp>
#include <eve/module/math/constant/two_pi.hpp>
#include <eve/module/math/constant/two_pio_3.hpp>
#include <eve/module/math/constant/zeta_2.hpp>
#include <eve/module/math/constant/zeta_3.hpp>
