//==================================================================================================
/*
  EVE - Expressive Vector Engine
  Copyright : EVE Project Contributors
  SPDX-License-Identifier: BSL-1.0
*/
//==================================================================================================
#pragma once

//==================================================================================================
//! @addtogroup functions
//! @{
//! @defgroup polynomial Polynomial functions
//!
//! @brief  This module provides implementation for scalar and SIMD versions of polynomial
//!         evaluation functions.
//!
//! **Convenience header:** @code{.cpp} #include <eve/module/polynomial.hpp> @endcode
//!
//! @}
//==================================================================================================
#include <eve/module/polynomial/regular/polynomial.hpp>
#include <eve/module/polynomial/pedantic/polynomial.hpp>
#include <eve/module/polynomial/numeric/polynomial.hpp>
